searchNodes=[{"doc":"Migrations are used to create your tables. Support the partition key is autoincrementing based on this library's wrapper, for this use case, we can use the migration to automatically create an another separated table to generate the serial value when :insert (viz ExAliyunOts.put_row/5 ) or :batch_write (viz ExAliyunOts.batch_write/3 ) with :put option. In practice, we don't create migration files by hand either, we typically use mix ecto.ots.gen.migration to generate the file with the proper timestamp and then we just fill in its contents: $ mix ecto . ots . gen . migration create_posts_table And then we can fill the table definition details: defmodule EctoTablestore.TestRepo.Migrations.CreatePostsTable do use EctoTablestore.Migration def change do create table ( &quot;ecto_ots_test_posts&quot; ) do add :post_id , :integer , partition_key : true , auto_increment : true end end end After we filled the above migration content, you can run the migration above by going to the root of your project and typing: $ mix ecto . ots . migrate Finally, we successfully create the &quot;ecto_ots_test_posts&quot; table, since the above definition added an autoincrementing column for the partition key, there will automatically create an &quot;ecto_ots_test_posts_seq&quot; table to generate a serial integer for :post_id field when insert a new record.","ref":"EctoTablestore.Migration.html","title":"EctoTablestore.Migration","type":"module"},{"doc":"Adds a primary key when creating a table. This function only accepts types as :string | :binary | :integer | :hashids | :id . About :auto_increment option: set :auto_increment as true and its field is primary key of non-partitioned key, there will use Tablestore's auto-increment column to process it. set :auto_increment as true and its field is partition key, there will use ex_aliyun_ots 's built-in Sequence function, the actual principle behind it is to use the atomic update operation though another separate table when generate serial integer, by default there will add an :id partition key as :integer type, the initial value of the sequence is 0, and the increment step is 1. Tablestore can only have up to 4 primary keys, meanwhile the first defined primary key is the partition key, Please know that the order of the primary key definition will be directly mapped to the created table. About :hashids type to define the partition key: set partition_key as true is required. set auto_increment as true is required. Examples The auto generated serial integer for partition key: create table ( &quot;posts&quot; ) do add :title , :string end # The above is equivalent to create table ( &quot;posts&quot; , partition_key : false ) do add :id , :integer , partition_key : true , auto_increment : true add :title , :string end The explicitly defined field with partition_key : create table ( &quot;posts&quot; ) do add :title , :string end # The above is equivalent to create table ( &quot;posts&quot; ) do add :id , :integer , partition_key : true , auto_increment : true add :title , :string end The :auto_increment integer for primary key of non-partitioned key: create table ( &quot;posts&quot; ) do add :tag , :integer , auto_increment : true end # The above is equivalent to create table ( &quot;posts&quot; , partition_key : false ) do add :id , :integer , partition_key : true , auto_increment : true add :version , :integer , auto_increment : true end The :hashids type for the partition key with the built-in sequence feature: create table ( &quot;posts&quot; ) do add :id , :hashids , auto_increment : true , partition_key : true end The :id type for the partition key with the built-in sequence feature: create table ( &quot;posts&quot; ) do add :id , :id end # The above is equivalent to create table ( &quot;posts&quot; , partition_key : false ) do add :id , :integer , partition_key : true , auto_increment : true end Options :partition_key - when true , marks this field as the partition key, only the first explicitly defined field is available for this option. :auto_increment - when true and this field is non-partitioned key, Tablestore automatically generates the primary key value, which is unique in the partition key, and which increases progressively, when true and this field is a partition key, use ex_aliyun_ots 's Sequence to build a serial number for this field, the auto_increment: true option only allows binding of one primary key.","ref":"EctoTablestore.Migration.html#add/3","title":"EctoTablestore.Migration.add/3","type":"macro"},{"doc":"Adds a column what already be pre-defined column when creating a secondary index.","ref":"EctoTablestore.Migration.html#add_column/1","title":"EctoTablestore.Migration.add_column/1","type":"macro"},{"doc":"Adds a pre-defined column when creating a table. This function only accepts types as :integer | :double | :boolean | :string | :binary . For more information see the Chinese Docs | English Docs Examples create table ( &quot;posts&quot; ) do add_pk ( :id , :integer , partition_key : true ) add_pk ( :owner_id , :string ) add_column ( :title , :string ) add_column ( :content , :string ) end","ref":"EctoTablestore.Migration.html#add_column/2","title":"EctoTablestore.Migration.add_column/2","type":"macro"},{"doc":"Adds a secondary index when creating a table. For more information see the Chinese Docs | English Docs Examples create table ( &quot;posts&quot; ) do add_pk ( :id , :integer , partition_key : true ) add_pk ( :owner_id , :string ) add_column ( :title , :string ) add_column ( :content , :string ) add_index ( &quot;posts_owner&quot; , [ :owner_id , :id ] , [ :title , :content ] ) add_index ( &quot;posts_title&quot; , [ :title , :id ] , [ :content ] ) end","ref":"EctoTablestore.Migration.html#add_index/3","title":"EctoTablestore.Migration.add_index/3","type":"macro"},{"doc":"Adds a primary key when creating a secondary index.","ref":"EctoTablestore.Migration.html#add_pk/1","title":"EctoTablestore.Migration.add_pk/1","type":"macro"},{"doc":"Adds a primary key when creating a table. Same as add/2 , see add/2 for more information.","ref":"EctoTablestore.Migration.html#add_pk/3","title":"EctoTablestore.Migration.add_pk/3","type":"macro"},{"doc":"Define the primary key(s) of the table to create. By default, the table will also include an :id primary key field (it is also partition key) that has a type of :integer which is an autoincrementing column. Check the table/2 docs for more information. There are up to 4 primary key(s) can be added when creation. Example create table ( &quot;posts&quot; ) do add :title , :string end # The above is equivalent to create table ( &quot;posts&quot; ) do add :id , :integer , partition_key : true , auto_increment : true add :title , :string end","ref":"EctoTablestore.Migration.html#create/2","title":"EctoTablestore.Migration.create/2","type":"macro"},{"doc":"Drops one of the following: a table a secondary index a search index Examples drop table ( &quot;posts&quot; ) drop secondary_index ( &quot;posts&quot; , &quot;posts_owner&quot; ) drop search_index ( &quot;posts&quot; , &quot;posts_index&quot; )","ref":"EctoTablestore.Migration.html#drop/1","title":"EctoTablestore.Migration.drop/1","type":"function"},{"doc":"Returns a search index struct that can be given to create/2 . For more information see the Chinese Docs | English Docs Examples create search_index ( &quot;posts&quot; , &quot;posts_owner&quot; ) do field_schema_keyword ( &quot;title&quot; ) field_schema_keyword ( &quot;content&quot; ) field_sort ( &quot;title&quot; ) end Please refer the link to the available field schema definition options, and the link to the available sort options.","ref":"EctoTablestore.Migration.html#search_index/3","title":"EctoTablestore.Migration.search_index/3","type":"function"},{"doc":"Returns a secondary index struct that can be given to create/2 . For more information see the Chinese Docs | English Docs Examples create secondary_index ( &quot;posts&quot; , &quot;posts_owner&quot; ) do add_pk ( :owner_id ) add_pk ( :id ) add_column ( :title ) add_column ( :content ) end Options :include_base_data , specifies whether the index table includes the existing data in the base table, if set it to true means the index includes the existing data, if set it to false means the index excludes the existing data, optional, by default it is true .","ref":"EctoTablestore.Migration.html#secondary_index/3","title":"EctoTablestore.Migration.secondary_index/3","type":"function"},{"doc":"Returns a table struct that can be given to create/2 . Since Tablestore is a NoSQL service, there are up to 4 primary key(s) can be added when creation, the first added key is partition key when set partition_key option as false. Examples create table ( &quot;products&quot; ) do add :name , :string add :price , :integer end create table ( &quot;products&quot; , partition_key : false ) do add :name , :string add :price , :integer end Options :partition_key - as true by default, and there will add an :id field as partition key with type as a large autoincrementing integer (as bigserial ), Tablestore does not support bigserial type for primary keys, but can use the ex_aliyun_ots lib's wrapper - Sequence to implement it; when false , a partition key field is not generated on table creation. :prefix - the prefix for the table. :meta - define the meta information when create table, can see Tablestore's document for details: :reserved_throughput_write - reserve the throughput for write when create table, an integer, the default value is 0; :reserved_throughput_read - reserve the throughput for read when create table, an integer, the default value is 0; :time_to_live - the survival time of the saved data, a.k.a TTL; an integer, unit as second, the default value is -1 (permanent preservation); :deviation_cell_version_in_sec - maximum version deviation, the default value is 86400 seconds, which is 1 day; stream_spec - set the stream specification of Tablestore: is_enabled , open or close stream expiration_time , the expiration time of the table's stream","ref":"EctoTablestore.Migration.html#table/2","title":"EctoTablestore.Migration.table/2","type":"function"},{"doc":"Defines a repository for Tablestore. A repository maps to an underlying data store, controlled by Ecto.Adapters.Tablestore adapter. When used, the repository expects the :otp_app option, and uses Ecto.Adapters.Tablestore by default. The :otp_app should point to an OTP application that has repository configuration. For example, the repository: defmodule EctoTablestore.MyRepo do use EctoTablestore.Repo , otp_app : :my_otp_app end Configure ex_aliyun_ots as usual: config :ex_aliyun_ots , MyInstance , name : &quot;MY_INSTANCE_NAME&quot; , endpoint : &quot;MY_INSTANCE_ENDPOINT&quot; , access_key_id : &quot;MY_OTS_ACCESS_KEY&quot; , access_key_secret : &quot;MY_OTS_ACCESS_KEY_SECRET&quot; config :ex_aliyun_ots , instances : [ MyInstance ] Add the following configuration to associate MyRepo with the previous configuration of ex_aliyun_ots : config :my_otp_app , EctoTablestore.MyRepo , instance : MyInstance","ref":"EctoTablestore.Repo.html","title":"EctoTablestore.Repo","type":"behaviour"},{"doc":"Returns the adapter tied to the repository.","ref":"EctoTablestore.Repo.html#c:__adapter__/0","title":"EctoTablestore.Repo.__adapter__/0","type":"callback"},{"doc":"Batch get several rows of data from one or more tables, this batch request put multiple get_row in one request from client's perspective. After execute each operation in servers, return results independently and independently consumes capacity units. When input schema_entity , only theirs primary keys are used in query, if need to use theirs attribute columns into condition of query, please use entity_full_match: true option to do that. Example batch_get ( [ { Schema1 , [ [ ids : ids1 ] , [ ids : ids2 ] ] } , [ % Schema2 { keys : keys1 } , % Schema2 { keys : keys2 } ] ] ) batch_get ( [ { Schema1 , [ [ ids : ids1 ] , [ ids : ids2 ] ] } , { [ % Schema2 { keys : keys1 } , % Schema2 { keys : keys2 } ] , entity_full_match : true } ] ) batch_get ( [ { [ % Schema2 { keys : keys1 } , % Schema2 { keys : keys2 } ] , filter : filter ( &quot;attr_field&quot; == 1 ) , columns_to_get : [ &quot;attr_field&quot; , &quot;attr_field2&quot; ] } ] )","ref":"EctoTablestore.Repo.html#c:batch_get/1","title":"EctoTablestore.Repo.batch_get/1","type":"callback"},{"doc":"Batch write several rows of data from one or more tables, this batch request put multiple put_row/delete_row/update_row in one request from client's perspective. After execute each operation in servers, return results independently and independently consumes capacity units. If use a batch write request include a transaction ID, all rows in that request can only be written to the table that matches the transaction ID. Options transaction_id , use local transaction. Example The options of each :put , :delete , and :update operation are similar as ExAliyunOts.put_row/5 , ExAliyunOts.delete_row/4 and ExAliyunOts.update_row/4 , but transaction_id option is using in the options of EctoTablestore.Repo.batch_write/2 . batch_write ( [ delete : [ schema_entity_1 , schema_entity_2 ] , put : [ { % Schema2 { } , condition : condition ( :ignore ) } , { % Schema1 { } , condition : condition ( :expect_not_exist ) } , { changeset_schema_1 , condition : condition ( :ignore ) } ] , update : [ { changeset_schema_1 , return_type : :pk } , { changeset_schema_2 } ] ] )","ref":"EctoTablestore.Repo.html#c:batch_write/2","title":"EctoTablestore.Repo.batch_write/2","type":"callback"},{"doc":"Delete a struct using its primary key. Options :condition , this option is required, whether to add conditional judgment before data delete. Two kinds of update condition types as below: As ` condition ( :expect_exist ) ` means the primary key ( s ) can match a row to delete , we also can add some compare expressions for the attribute columns , e . g . 1 . condition ( :expect_exist , &quot;attr1&quot; == value1 and &quot;attr2&quot; &gt; 1 ) 2 . condition ( :expect_exist , &quot;attr1&quot; != value1 ) 3 . condition ( :expect_exist , &quot;attr1&quot; &gt; 100 or &quot;attr2&quot; &lt; 1000 ) As ` condition ( :ignore ) ` means DO NOT do any condition validation before delete . :transaction_id , delete under local transaction in a partition key. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError . :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;.","ref":"EctoTablestore.Repo.html#c:delete/2","title":"EctoTablestore.Repo.delete/2","type":"callback"},{"doc":"Fetch a single struct from tablestore where the whole primary key(s) match the given ids. Options :columns_to_get , string list, return the specified attribute columns, if not specify this option field, will try to return all attribute columns together. :start_column , string, used as a starting column for Wide Column read, the return result contains this as starter. :end_column , string, used as a ending column for Wide Column read, the return result DON NOT contain this column. :filter , used as a filter by condition, support &quot;&gt;&quot; , &quot;&lt;&quot; , &quot;&gt;=&quot; , &quot;&lt;=&quot; , &quot;==&quot; , &quot;and&quot; , &quot;or&quot; and &quot;()&quot; expressions. The ignore_if_missing option can be used for the non-existed attribute column, for example: An attribute column does not exist meanwhile set it as true , will ignore this match condition in the return result; An existed attribute column DOES NOT suit for this use case, the match condition will always affect the return result, if match condition does not satisfy, they won't be return in result. filter : filter ( ( { &quot;name&quot; , ignore_if_missing : true } == var_name and &quot;age&quot; &gt; 1 ) or ( &quot;class&quot; == &quot;1&quot; ) ) :transaction_id , read under local transaction in a partition key.","ref":"EctoTablestore.Repo.html#c:get/3","title":"EctoTablestore.Repo.get/3","type":"callback"},{"doc":"Get multiple structs by range from one table, rely on the conjunction of the partition key and other primary key(s). Options :direction , by default it is :forward , set it as :forward to make the order of the query result in ascending by primary key(s), set it as :backward to make the order of the query result in descending by primary key(s). :columns_to_get , string list, return the specified attribute columns, if not specify this field all attribute columns will be return. :start_column , string, used as a starting column for Wide Column read, the return result contains this as starter. :end_column , string, used as a ending column for Wide Column read, the return result DON NOT contain this column. :limit , optional, the maximum number of rows of data to be returned, this value must be greater than 0, whether this option is set or not, there returns a maximum of 5,000 data rows and the total data size never exceeds 4 MB. :transaction_id , read under local transaction in a partition key. :filter , used as a filter by condition, support &quot;&gt;&quot; , &quot;&lt;&quot; , &quot;&gt;=&quot; , &quot;&lt;=&quot; , &quot;==&quot; , &quot;and&quot; , &quot;or&quot; and &quot;()&quot; expressions. The ignore_if_missing option can be used for the non-existed attribute column, for example: An attribute column does not exist meanwhile set it as true , will ignore this match condition in the return result; An existed attribute column DOES NOT suit for this use case, the match condition will always affect the return result, if match condition does not satisfy, they won't be return in result. filter : filter ( ( { &quot;name&quot; , ignore_if_missing : true } == var_name and &quot;age&quot; &gt; 1 ) or ( &quot;class&quot; == &quot;1&quot; ) )","ref":"EctoTablestore.Repo.html#c:get_range/4","title":"EctoTablestore.Repo.get_range/4","type":"callback"},{"doc":"Inserts a struct defined via EctoTablestore.Schema or a changeset. Options :condition , this option is required, whether to add conditional judgment before date insert. Two kinds of insert condition types as below: As condition(:ignore) means DO NOT do any condition validation before insert, if the schema non-partitioned primary key is auto increment, we can only use condition(:ignore) option. As condition(:expect_not_exist) means the primary key(s) are NOT existed before insert. * :transaction_id , insert under local transaction in a partition key.","ref":"EctoTablestore.Repo.html#c:insert/2","title":"EctoTablestore.Repo.insert/2","type":"callback"},{"doc":"Similar to get/3 , please ensure schema entity has been filled with the whole primary key(s). Options :entity_full_match , whether to transfer the input attribute column(s) into the :== filtering expressions, by default it is false , when set entity_full_match: true , please notice the following rules: If there exists attribute column(s) provided in entity, these fields will be combined within multiple :== filtering expressions; If there exists attribute column(s) provided and meanwhile set filter option, they will be merged into a composite filter. Other options please refer get/3 .","ref":"EctoTablestore.Repo.html#c:one/2","title":"EctoTablestore.Repo.one/2","type":"callback"},{"doc":"Provide search index features for the following scenarios: MatchAllQuery MatchQuery MatchPhraseQuery TermQuery TermsQuery PrefixQuery RangeQuery WildcardQuery BoolQuery NestedQuery ExistsQuery GeoBoundingBoxQuery GeoDistanceQuery GeoPolygonQuery Please refer ExAliyunOts.Search query section for details, they are similar options for use, for example: MyRepo . search ( MySchema , &quot;index_name&quot; , search_query : [ query : exists_query ( &quot;comment&quot; ) ] )","ref":"EctoTablestore.Repo.html#c:search/3","title":"EctoTablestore.Repo.search/3","type":"callback"},{"doc":"Please see Ecto.Repo.start_link/1 for details.","ref":"EctoTablestore.Repo.html#c:start_link/1","title":"EctoTablestore.Repo.start_link/1","type":"callback"},{"doc":"As a wrapper built on stream_range/4 to create composable and lazy enumerables stream for iteration. Options Please see options of get_range/4 for details.","ref":"EctoTablestore.Repo.html#c:stream/2","title":"EctoTablestore.Repo.stream/2","type":"callback"},{"doc":"As a wrapper built on ExAliyunOts.stream_range/5 to create composable and lazy enumerables stream for iteration. Options Please see options of get_range/4 for details.","ref":"EctoTablestore.Repo.html#c:stream_range/4","title":"EctoTablestore.Repo.stream_range/4","type":"callback"},{"doc":"As a wrapper built on ExAliyunOts.stream_search/4 to create composable and lazy enumerables stream for iteration. Options Please see options of search/3 for details.","ref":"EctoTablestore.Repo.html#c:stream_search/3","title":"EctoTablestore.Repo.stream_search/3","type":"callback"},{"doc":"Updates a changeset using its primary key. Options :condition , this option is required, whether to add conditional judgment before data update. Two kinds of update condition types as below: As condition(:expect_exist) means the primary key(s) can match a row to update, we also can add some compare expressions for the attribute columns, e.g. condition(:expect_exist, &quot;attr1&quot; == value1 and &quot;attr2&quot; &gt; 1) condition(:expect_exist, &quot;attr1&quot; != value1) condition(:expect_exist, &quot;attr1&quot; &gt; 100 or &quot;attr2&quot; &lt; 1000) As condition(:ignore) means DO NOT do any condition validation before update. :transaction_id , update under local transaction in a partition key. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError . :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;. :returning , this option is required when the input changeset with :increment operation, all fields of the atomic increment operation are required to explicitly set into this option in any order, if missed any atomic increment operation related field, there will raise an Ecto.ConstraintError to prompt and terminate this update. If there is no :increment operation, the :returning option is no need to set. If set returning: true , but not really all fields are changed, the unchanged fields will be replaced as nil in the returned schema data.","ref":"EctoTablestore.Repo.html#c:update/2","title":"EctoTablestore.Repo.update/2","type":"callback"},{"doc":"","ref":"EctoTablestore.Repo.html#t:options/0","title":"EctoTablestore.Repo.options/0","type":"type"},{"doc":"","ref":"EctoTablestore.Repo.html#t:schema/0","title":"EctoTablestore.Repo.schema/0","type":"type"},{"doc":"","ref":"EctoTablestore.Repo.html#t:schema_or_changeset/0","title":"EctoTablestore.Repo.schema_or_changeset/0","type":"type"},{"doc":"","ref":"EctoTablestore.Repo.html#t:search_result/0","title":"EctoTablestore.Repo.search_result/0","type":"type"},{"doc":"Defines a schema for Tablestore. An Ecto schema is used to map any data source into an Elixir struct. The definition of the schema is possible through the API: tablestore_schema/2 . tablestore_schema/2 is typically used to map data from a persisted source, usually a Tablestore table, into Elixir structs and vice-versa. For this reason, the first argument of tablestore_schema/2 is the source(table) name. Structs defined with tablestore_schema/2 also contain a __meta__ field with metadata holding the status of struct, for example, if it has bee built, loaded or deleted. Since Tablestore is a NoSQL database service, embedded_schema/1 is not supported so far. About timestamps Since Tablestore's column does not support DateTime type, use UTC timestamp (:integer type) as timestamps() macro for the generated inserted_at and updated_at fields by default. About primary key The primary key supports :id (integer()) and :binary_id (binary()). By default the :primary_key option is false . The first defined primary key by the written order in the tablestore_schema is the partition key. Up to 4 primary key(s), it is limited by TableStore product server side. Up to 1 primary key with autogenerate: true option, it is limited by TableStore product server side. The primary key set with autogenerate: true will use the TableStore product server's AUTO_INCREMENT feature. If the partition key set as autogenerate: true is not allowed to take advantage of the AUTO_INCREMENT feature which it is limited by server, but there is a built-in implement to use the Sequence to achieve the same atomic increment operation in ecto_tablestore library. Example defmodule User do use EctoTablestore.Schema tablestore_schema &quot;users&quot; do field :outer_id , :binary_id , primary_key : true field :internal_id , :id , primary_key : true , autogenerate : true field :name , :string field :desc end end By default, if not explicitly set field type will process it as :string type.","ref":"EctoTablestore.Schema.html","title":"EctoTablestore.Schema","type":"module"},{"doc":"","ref":"EctoTablestore.Schema.html#tablestore_schema/2","title":"EctoTablestore.Schema.tablestore_schema/2","type":"macro"},{"doc":"Generate a migration to create a table of tablestore. The repository must be set under :ecto_repos in the current app configuration, or given via the -r option: Example 1 1, Add configuration: config :your_app , ecto_repos : [ EctoTablestore.TestRepo ] 2, Run: mix ecto . ots . gen . migration create_posts Example 2 1, Run: mix ecto . ots . gen . migration create_posts - r EctoTablestore.TestRepo The generated migration filename will be prefixed with the current timestamp in UTC which is used for versioning and ordering. By default, the migration will be generated to the &quot;priv/tablestore/YOUR_REPO/migrations&quot; directory of the current application but it can be configured to be any subdirectory of priv by specifying the :priv key under the repository configuration. Command line options -r , --repo - the repo to generate migration for","ref":"Mix.Tasks.Ecto.Ots.Gen.Migration.html","title":"Mix.Tasks.Ecto.Ots.Gen.Migration","type":"task"},{"doc":"Runs the all migration for the given repository. Migrations are expected at &quot;priv/tablestore/YOUR_REPO/migrations&quot; directory of the current application, where &quot;YOUR_REPO&quot; is the last segment in your repository name. For example, the repository MyApp.Repo will use &quot;priv/tablestore/repo/migrations&quot;, the repository Whatever.MyRepo will use &quot;priv/tablestore/my_repo/migrations&quot;. Alibaba Tablestore is a cloud service product, there will not do any local storage, meanwhile it is a NoSQL data storage, the migrations mainly responsible for the creation of the table primary key(s). Currently, run migrations will execute the all defined tasks, once Tablestore's primary key(s) are created, the primary keys(s) cannot be modified, failed to create an existing table, we can ignore it. Example mix ecto . ots . migrate mix ecto . ots . migrate - r EctoTablestore.TestRepo Command line options -r , --repo - the repo to migrate","ref":"Mix.Tasks.Ecto.Ots.Migrate.html","title":"Mix.Tasks.Ecto.Ots.Migrate","type":"task"},{"doc":"Alibaba Tablestore adapter for Ecto","ref":"readme.html","title":"Alibaba Tablestore adapter for Ecto","type":"extras"},{"doc":"If you have used this library and upgrade it into 0.11.0 or later, there are some breaking changes in 0.11.0 , you may need to make a data migration before upgrade and one use case check, please see this changelog for details, if you are new to use 0.11.0 or later, please ignore this comment.","ref":"readme.html#notice","title":"Alibaba Tablestore adapter for Ecto - Notice","type":"extras"},{"doc":"Ecto 3.x adapter for Alibaba Tablestore , this is built on top of ex_aliyun_ots to implement Ecto.Adapter and Ecto.Adapter.Schema behaviours. Supported features: Compatible Ecto.Repo API. Support schema's timestamps() macro, make inserted_at and updated_at as an integer UTC timestamps. Support :map | {:map, _} | :array | {:array, _} field type, use Jason to encode the field value into :string when save, use Jason to simply decode the field value into :map | :array when read, the :keys option of Jason's decode always use :string. Support the partition key is autoincrementing, use the sequence feature provided by ex_aliyun_ots . Automatically converts the returned original row results into corresponding schema(s). Automatically generate the provided attribute-column field(s) of schema entity into the filter expression option of GetRow (see EctoTablestore.Repo.one/2 ) and BatchGet (see EctoTablestore.Repo.batch_get/1 ) use entity_full_match: true , by default this option is false . Automatically generate the provided attribute-column field(s) of schema entity into the condition expression option of BatchWrite . Automatically map changeset's attribute-column field(s) into UpdateRow operation when call EctoTablestore.Repo.update/2 : Use atomic increment via {:increment, integer()} in changeset, and return the increased value in the corresponding field(s) by default; Set any attribute(s) of schema changeset as nil will :delete_all that attribute-column field(s); Set existed attribute(s) in schema changeset will :put to save. Support embedded schema, please refer full functions of Ecto.Schema for details. Implement Tablestore row related functions in EctoTablestore.Repo module, please see document for details: PutRow GetRow UpdateRow DeleteRow GetRange StreamRange BatchGetRow BatchWriteRow Search","ref":"readme.html#introduce","title":"Alibaba Tablestore adapter for Ecto - Introduce","type":"extras"},{"doc":"Provide a simple migration to create or drop the table, the secondary index and the search index, please see EctoTablestore.Migration for details.","ref":"readme.html#migration","title":"Alibaba Tablestore adapter for Ecto - Migration","type":"extras"},{"doc":"1, Configure My instance(s) information of Alibaba Tablestore product. use Mix.Config # config for `ex_aliyun_ots` config :ex_aliyun_ots , MyInstance , name : &quot;MY_INSTANCE_NAME&quot; , endpoint : &quot;MY_INSTANCE_ENDPOINT&quot; , access_key_id : &quot;MY_OTS_ACCESS_KEY&quot; , access_key_secret : &quot;MY_OTS_ACCESS_KEY_SECRET&quot; config :ex_aliyun_ots , instances : [ MyInstance ] # config for `ecto_tablestore` config :my_otp_app , EctoTablestore.MyRepo , instance : MyInstance 2, Create the EctoTablestore.MyRepo module mentioned earlier in the configuration, use EctoTablestore.Repo and set required otp_app option with your OTP application's name. defmodule EctoTablestore.MyRepo do use EctoTablestore.Repo , otp_app : :my_otp_app end 3, Each repository in Ecto defines a start_link/0 function that needs to be invoked before using the repository. In general, this function is not called directly, but used as part of your application supervision tree. Add EctoTablestore.MyRepo into your application start callback that defines and start your supervisor. You just need to edit start/2 function to start the repo as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { EctoTablestore.MyRepo , [ ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end 4, After finish the above preparation, we can use MyRepo to operate data store.","ref":"readme.html#usage","title":"Alibaba Tablestore adapter for Ecto - Usage","type":"extras"},{"doc":"Base on unique integer of atomic-increment sequence, provides a way to simply integrate Hashids to generate your hash ids when insert row(s), for Repo.insert/2 or Repo.batch_write/1 . Use in schema defmodule Module do use EctoTablestore.Schema tablestore_schema &quot;table_name&quot; do field ( :id , :hashids , primary_key : true , autogenerate : true , hashids : [ salt : &quot;123&quot; , min_len : 2 , alphabet : &quot;...&quot; ] ) field ( :content , :string ) end end Options: The primary_key as true is required; The autogenerate as true is required; The salt , min_len and alphabet of hashids options are used for configuration options from Hashids.new/1 . Notice: the salt , min_len and alphabet of hashids options also can be configured in the :ecto_tablestore config for each defined schema, for example: config :ecto_tablestore , hashids : [ { Module , salt : &quot;...&quot; , min_len : 16 , alphabet : &quot;...&quot; } , ... ] Use in migration Use :hashids as a type in add operation to define the partition key, the principle behind this will use ecto_tablestore_default_seq as a global default table to maintain the sequences of all tables, if ecto_tablestore_default_seq is not existed, there will create this, if it is existed, please ignore the &quot;OTSObjectAlreadyExist&quot; error of requested table already exists. defmodule EctoTablestore.TestRepo.Migrations.TestHashids do use EctoTablestore.Migration def change do create table ( &quot;table_name&quot; ) do add :id , :hashids , partition_key : true add :oid , :integer end end end Options: The partition_key option as true is required; The auto_increment option is ignored when the partition key is :hashids type.","ref":"readme.html#integrate-hashids","title":"Alibaba Tablestore adapter for Ecto - Integrate Hashids","type":"extras"},{"doc":"Alibaba Tablestore product official references: English document 中文文档","ref":"readme.html#references","title":"Alibaba Tablestore adapter for Ecto - References","type":"extras"},{"doc":"This project is licensed under the MIT license. Copyright (c) 2018- Xin Zou.","ref":"readme.html#license","title":"Alibaba Tablestore adapter for Ecto - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"[Need to migrate before upgrade] When define the type of partition key as an auto increment integer, we created a &quot;\#{table_name}_seq&quot; table as an internal sequence to the &quot;\#{table_name}&quot; table, but now all sequence(s) managed into the &quot;ecto_tablestore_default_seq&quot; table, see #16 . Add Repo.stream_search/3 , see #17 . Add Repo.stream/2 , see #21 . Add Repo.get_range/1 and Repo.get_range/2 for easy use, see #28 . Support changeset optimistic_lock in update, see commit 66f6823 . [Need to check before upgrade] Fix update with :increment operation return an unexpected result when schema has multi integer fields defined, and require to explicitly add column name(s) which are related in the atomic increment operation into the :returning option of Repo.update/2 , see #19 . Fix to properly handle the stale error case when insert, see #20 . Fix to remove the useless supervisor name to resolve duplicated naming conflict in some cases, see #24 .","ref":"changelog.html#v0-11-0-2021-05-14","title":"Changelog - v0.11.0 (2021-05-14)","type":"extras"}]